
template behavior<method METH> RealTimeAdvocate_T ()
{
    qosket Qosket::Basic::BasicTaskQosket rta_Qosket;
    ivar Broker::RealTimeTask rta_Advocate;
    ivar Broker::CPUReserve rta_CPUReserve;
    ivar Broker::KeyedReportParameters rta_KeyedReportParameters;
    ivar unsigned long rta_Period;
    ivar unsigned long rta_Deadline;
    ivar unsigned long rta_UsageStart_Sec;
    ivar unsigned long rta_UsageStart_uSec;

    METH.signature {
	before PREMETHODCONTRACTEVAL {} // XXX

	after methodcall {
	    java_code #{
		long curr, last_start, diff;

		curr = this.rta_Qosket.RUsage();
		if( (this.rta_UsageStart_Sec == 0) &&
		    (this.rta_UsageStart_uSec == 0) )
		{
		    this.rta_UsageStart_Sec = (int)(curr / 1000000L);
		    this.rta_UsageStart_uSec = (int)(curr % 1000000L);
		}
		last_start = this.rta_UsageStart_Sec * 1000000;
		last_start += this.rta_UsageStart_uSec;
		diff = curr - last_start;
		this.rta_UsageStart_Sec = (int)(curr / 1000000L);
		this.rta_UsageStart_uSec = (int)(curr % 1000000L);
		try
		{
		    this.rta_CPUReserve.Period = this.rta_Period;
		    this.rta_CPUReserve.Compute = (int)diff;
		    this.rta_Advocate.ReportCPU(this.rta_CPUReserve,
						this.rta_CPUReserve,
						this.rta_KeyedReportParameters);
		}
		catch(Exception e)
		{
		    e.printStackTrace();
		}
	    }#;
	}
    }
};

/**
 * @sa Broker.idl
 * @sa RTServer.idl
 */
behavior ATRDelegate () {
    RealTimeAdvocate_T<FrameManip::Processor::process>;
};
