/*
 * FakeDelegate.cc
 *
 * Copyright (c) 2003 The University of Utah and the Flux Group.
 * All rights reserved.
 *
 * This file is licensed under the terms of the GNU Public License.  
 * See the file "license.terms" for restrictions on redistribution 
 * of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 */

/**
 * @file FakeDelegate.cc
 *
 * Implementation of the FakeDelegate class.
 */

#include "config.h"

#include <iostream>

#include <assert_pp.h>

#include <rk_stub.h>

#include "FakeDelegate.hh"

FakeDelegate::FakeDelegate()
{
}

FakeDelegate::~FakeDelegate()
{
}

rk_stub_precall_retval_t cxx_delegate_precall(void *obj)
{
    FakeDelegate *delegate = (FakeDelegate *)obj;
    rk_stub_precall_retval_t retval;

    require(obj != NULL);
    
    retval = delegate->precall();
    return( retval );
}

void cxx_delegate_postcall(void *obj)
{
    FakeDelegate *delegate = (FakeDelegate *)obj;
    
    require(obj != NULL);
    
    delegate->postcall();
}
