/*
 * BasicTaskCallbackImpl.cc
 *
 * Copyright (c) 2003, 2004 The University of Utah and the Flux Group.
 * All rights reserved.
 *
 * This file is licensed under the terms of the GNU Public License.  
 * See the file "license.terms" for restrictions on redistribution 
 * of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 */

/**
 * @file BasicTaskCallbackImpl.cc
 *
 * Implementation of the BasicTaskCallbackImpl class.
 */

#include "config.h"

#include <iostream>
#include <assert_pp.h>

#include "BasicTaskCallbackImpl.hh"

using namespace std;

void BasicTaskCallbackImpl::sendMessage(const char *msg)
    throw (CORBA::SystemException)
{
    require(msg != NULL);
    
    cerr << msg << endl;
}

void BasicTaskCallbackImpl::MissedDeadline(void)
    throw (CORBA::SystemException)
{
    this->sendMessage("Missed deadline");
}

void BasicTaskCallbackImpl::MadeDeadline(void)
    throw (CORBA::SystemException)
{
    this->sendMessage("Made deadline");
}
